           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_IF = Csp_semantics:

(*****************************************************************

         1. [[ ]]t
         2. [[ ]]f
         3.
         4. 

 *****************************************************************)

(*********************************************************
                  Condition trace eval
 *********************************************************)

lemma IFt_eval:
  "ALL b P Q ev. [[IF b THEN P ELSE Q]]T ev 
                 = (if b then ([[P]]T ev) else ([[Q]]T ev))"
apply (simp add: eval_T_def)
done

(*********************************************************
                  Condition failure eval
 *********************************************************)

lemma IFf_eval:
  "ALL b P Q ev. [[IF b THEN P ELSE Q]]F ev 
                 = (if b then ([[P]]F ev) else ([[Q]]F ev))"
apply (simp add: eval_F_def)
done

end
