           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_proof_STOP = Csp_proof_commut:

(*****************************************************************

         1. STOP laws
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                    ? :{} -> Pf    = STOP
 *********************************************************)

lemma eq_Pre_choice_empty: "? :{} -> Pf =F<ev> ? x:{} -> DIV"
apply (simp add: eqsf_decompo)
apply (simp add: Pre_choicet_eval)
apply (simp add: Pre_choicef_eval)
done

(*********************************************************
                     STOP [+] P
 *********************************************************)

lemma eq_Ext_choice_unit_l: "? x:{} -> DIV [+] P =F<ev> P"
apply (simp add: eqsf_decompo)
apply (rule conjI)

apply (simp add: Ext_choicet_eval)
apply (simp add: Pre_choicet_eval)
apply (rule equalityI)

  (* <= *)

apply (rule subsetI)
apply (simp)
apply (erule disjE)
apply (simp add: eval_T_in nil_t_in_all_dom)
apply (simp)

apply (rule subsetI)
apply (simp)

apply (simp add: Ext_choicef_eval)
apply (simp add: Pre_choicef_eval)
apply (simp add: tick_notin_Pre_choicet)

apply (rule equalityI)
apply (rule subsetI)
apply (simp)

apply (erule disjE)
apply (elim conjE exE)
apply (simp)

apply (erule disjE)
apply (simp add: pair_fun_apply)
apply (erule conjE)+
apply (simp)

apply (elim conjE exE)

apply (simp add: T2_F1_Tick)

  (* => *)

apply (rule subsetI)
apply (simp)

apply (insert trace_nil_or_Tick_or_Ev)
apply (drule_tac x="fst x" in spec)

apply (erule disjE)
apply (rule disjI1)
apply (rule_tac x="snd x" in exI)
apply (drule sym)
apply (simp)

apply (erule disjE)
apply (rule disjI2)
apply (rule disjI1)
apply (simp add: pair_fun_apply)
apply (simp add: nil_in_trace event_in_trace Abs_trace_inject)
apply (drule sym)
apply (simp)

apply (rule disjI2)
apply (rule disjI1)
apply (elim conjE exE)
apply (simp add: pair_fun_apply)
apply (simp add: event_app_not_nil)
apply (drule sym)
apply (simp)
done

(*********************************************************
                     P [+] STOP
 *********************************************************)

lemma eq_Ext_choice_unit_r: "P [+] ? x:{} -> DIV =F<ev> P"
apply (rule eqsf_trans)
apply (rule eq_Ext_choice_commut)
apply (rule eq_Ext_choice_unit_l)
done

end
